/* this file was generated by the MCOP idl compiler - DO NOT EDIT */

#ifndef KMEDIA2_H
#define KMEDIA2_H

#include "common.h"

enum poState {posPlaying = 0, posFinished = 1, posPaused = 2};
enum poCapabilities {capSeek = 1, capPause = 2};
class poTime : public Type {
public:
	poTime();
	poTime(long seconds, long ms, float custom, const std::string& customUnit);
	poTime(Buffer& stream);
	poTime(const poTime& copyType);
	poTime& operator=(const poTime& assignType);
	virtual ~poTime();

	long seconds;
	long ms;
	float custom;
	std::string customUnit;

// marshalling functions
	void readType(Buffer& stream);
	void writeType(Buffer& stream) const;
};

class PlayObject_private;
class PlayObject;
class PlayObjectFactory;

class PlayObject_private_base : virtual public Object_base {
public:
	static unsigned long _IID; // interface ID

	static PlayObject_private_base *_create(const std::string& subClass = "PlayObject_private");
	static PlayObject_private_base *_fromString(std::string objectref);
	static PlayObject_private_base *_fromReference(ObjectReference ref, bool needcopy);

	inline PlayObject_private_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual vector<std::string> _defaultPortsIn() const;
	virtual vector<std::string> _defaultPortsOut() const;

	void *_cast(unsigned long iid);

	virtual bool loadMedia(const std::string& filename) = 0;
};

class PlayObject_private_stub : virtual public PlayObject_private_base, virtual public Object_stub {
protected:
	PlayObject_private_stub();

public:
	PlayObject_private_stub(Connection *connection, long objectID);

	bool loadMedia(const std::string& filename);
};

class PlayObject_private_skel : virtual public PlayObject_private_base, virtual public Object_skel {
public:
	PlayObject_private_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class PlayObject_private : public SmartWrapper {
private:
	static Object_base* _Creator();
	PlayObject_private_base *_cache;
	inline PlayObject_private_base *_method_call() {
		_pool->checkcreate();
		if(_pool->base) {
			_cache=(PlayObject_private_base *)_pool->base->_cast(PlayObject_private_base::_IID);
			assert(_cache);
		}
		return _cache;
	}

public:
	inline PlayObject_private() : SmartWrapper(_Creator), _cache(0) {}
	inline PlayObject_private(const SubClass& s) :
		SmartWrapper(PlayObject_private_base::_create(s.string())), _cache(0) {}
	inline PlayObject_private(const Reference &r) :
		SmartWrapper(r.isString()?(PlayObject_private_base::_fromString(r.string())):(PlayObject_private_base::_fromReference(r.reference(),true))), _cache(0) {}
	inline PlayObject_private(PlayObject_private_base* b) : SmartWrapper(b), _cache(0) {}
	inline PlayObject_private(const PlayObject_private& target) : SmartWrapper(target._pool), _cache(target._cache) {}
	inline PlayObject_private(SmartWrapper::Pool& p) : SmartWrapper(p), _cache(0) {}
	inline PlayObject_private& operator=(const PlayObject_private& target) {
		if (_pool == target._pool) return *this;
		_pool->Dec();
		_pool = target._pool;
		_cache = target._cache;
		_pool->Inc();
		return *this;
	}
	inline operator Object() const { return Object(*_pool); }
	inline PlayObject_private_base* _base() {return _cache?_cache:_method_call();}

	inline bool loadMedia(const std::string& filename) {return _cache?_cache->loadMedia(filename):_method_call()->loadMedia(filename);}
};

class PlayObject_base : virtual public PlayObject_private_base {
public:
	static unsigned long _IID; // interface ID

	static PlayObject_base *_create(const std::string& subClass = "PlayObject");
	static PlayObject_base *_fromString(std::string objectref);
	static PlayObject_base *_fromReference(ObjectReference ref, bool needcopy);

	inline PlayObject_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual vector<std::string> _defaultPortsIn() const;
	virtual vector<std::string> _defaultPortsOut() const;

	void *_cast(unsigned long iid);

	virtual std::string description() = 0;
	virtual void description(const std::string& newValue) = 0;
	virtual poTime* currentTime() = 0;
	virtual void currentTime(const poTime& newValue) = 0;
	virtual poTime* overallTime() = 0;
	virtual poCapabilities capabilities() = 0;
	virtual std::string mediaName() = 0;
	virtual poState state() = 0;
	virtual void play() = 0;
	virtual void seek(const poTime& newTime) = 0;
	virtual void pause() = 0;
};

class PlayObject_stub : virtual public PlayObject_base, virtual public PlayObject_private_stub {
protected:
	PlayObject_stub();

public:
	PlayObject_stub(Connection *connection, long objectID);

	std::string description();
	void description(const std::string& newValue);
	poTime* currentTime();
	void currentTime(const poTime& newValue);
	poTime* overallTime();
	poCapabilities capabilities();
	std::string mediaName();
	poState state();
	void play();
	void seek(const poTime& newTime);
	void pause();
};

class PlayObject_skel : virtual public PlayObject_base, virtual public PlayObject_private_skel {
public:
	PlayObject_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class PlayObject : public SmartWrapper {
private:
	static Object_base* _Creator();
	PlayObject_base *_cache;
	inline PlayObject_base *_method_call() {
		_pool->checkcreate();
		if(_pool->base) {
			_cache=(PlayObject_base *)_pool->base->_cast(PlayObject_base::_IID);
			assert(_cache);
		}
		return _cache;
	}

public:
	inline PlayObject() : SmartWrapper(_Creator), _cache(0) {}
	inline PlayObject(const SubClass& s) :
		SmartWrapper(PlayObject_base::_create(s.string())), _cache(0) {}
	inline PlayObject(const Reference &r) :
		SmartWrapper(r.isString()?(PlayObject_base::_fromString(r.string())):(PlayObject_base::_fromReference(r.reference(),true))), _cache(0) {}
	inline PlayObject(PlayObject_base* b) : SmartWrapper(b), _cache(0) {}
	inline PlayObject(const PlayObject& target) : SmartWrapper(target._pool), _cache(target._cache) {}
	inline PlayObject(SmartWrapper::Pool& p) : SmartWrapper(p), _cache(0) {}
	inline PlayObject& operator=(const PlayObject& target) {
		if (_pool == target._pool) return *this;
		_pool->Dec();
		_pool = target._pool;
		_cache = target._cache;
		_pool->Inc();
		return *this;
	}
	inline operator PlayObject_private() const { return PlayObject_private(*_pool); }
	inline operator Object() const { return Object(*_pool); }
	inline PlayObject_base* _base() {return _cache?_cache:_method_call();}

	inline std::string description() {return _cache?_cache->description():_method_call()->description();}
	inline void description(const std::string& newValue) {_cache?_cache->description(newValue):_method_call()->description(newValue);}
	inline poTime* currentTime() {return _cache?_cache->currentTime():_method_call()->currentTime();}
	inline void currentTime(const poTime& newValue) {_cache?_cache->currentTime(newValue):_method_call()->currentTime(newValue);}
	inline poTime* overallTime() {return _cache?_cache->overallTime():_method_call()->overallTime();}
	inline poCapabilities capabilities() {return _cache?_cache->capabilities():_method_call()->capabilities();}
	inline std::string mediaName() {return _cache?_cache->mediaName():_method_call()->mediaName();}
	inline poState state() {return _cache?_cache->state():_method_call()->state();}
	inline void play() {return _cache?_cache->play():_method_call()->play();}
	inline void seek(const poTime& newTime) {return _cache?_cache->seek(newTime):_method_call()->seek(newTime);}
	inline void pause() {return _cache?_cache->pause():_method_call()->pause();}
	inline bool loadMedia(const std::string& filename) {return _cache?_cache->loadMedia(filename):_method_call()->loadMedia(filename);}
};

class PlayObjectFactory_base : virtual public Object_base {
public:
	static unsigned long _IID; // interface ID

	static PlayObjectFactory_base *_create(const std::string& subClass = "PlayObjectFactory");
	static PlayObjectFactory_base *_fromString(std::string objectref);
	static PlayObjectFactory_base *_fromReference(ObjectReference ref, bool needcopy);

	inline PlayObjectFactory_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual vector<std::string> _defaultPortsIn() const;
	virtual vector<std::string> _defaultPortsOut() const;

	void *_cast(unsigned long iid);

	virtual PlayObject createPlayObject(const std::string& filename) = 0;
};

class PlayObjectFactory_stub : virtual public PlayObjectFactory_base, virtual public Object_stub {
protected:
	PlayObjectFactory_stub();

public:
	PlayObjectFactory_stub(Connection *connection, long objectID);

	PlayObject createPlayObject(const std::string& filename);
};

class PlayObjectFactory_skel : virtual public PlayObjectFactory_base, virtual public Object_skel {
public:
	PlayObjectFactory_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class PlayObjectFactory : public SmartWrapper {
private:
	static Object_base* _Creator();
	PlayObjectFactory_base *_cache;
	inline PlayObjectFactory_base *_method_call() {
		_pool->checkcreate();
		if(_pool->base) {
			_cache=(PlayObjectFactory_base *)_pool->base->_cast(PlayObjectFactory_base::_IID);
			assert(_cache);
		}
		return _cache;
	}

public:
	inline PlayObjectFactory() : SmartWrapper(_Creator), _cache(0) {}
	inline PlayObjectFactory(const SubClass& s) :
		SmartWrapper(PlayObjectFactory_base::_create(s.string())), _cache(0) {}
	inline PlayObjectFactory(const Reference &r) :
		SmartWrapper(r.isString()?(PlayObjectFactory_base::_fromString(r.string())):(PlayObjectFactory_base::_fromReference(r.reference(),true))), _cache(0) {}
	inline PlayObjectFactory(PlayObjectFactory_base* b) : SmartWrapper(b), _cache(0) {}
	inline PlayObjectFactory(const PlayObjectFactory& target) : SmartWrapper(target._pool), _cache(target._cache) {}
	inline PlayObjectFactory(SmartWrapper::Pool& p) : SmartWrapper(p), _cache(0) {}
	inline PlayObjectFactory& operator=(const PlayObjectFactory& target) {
		if (_pool == target._pool) return *this;
		_pool->Dec();
		_pool = target._pool;
		_cache = target._cache;
		_pool->Inc();
		return *this;
	}
	inline operator Object() const { return Object(*_pool); }
	inline PlayObjectFactory_base* _base() {return _cache?_cache:_method_call();}

	inline PlayObject createPlayObject(const std::string& filename) {return _cache?_cache->createPlayObject(filename):_method_call()->createPlayObject(filename);}
};

#endif /* KMEDIA2_H */
