/* this file was generated by the MCOP idl compiler - DO NOT EDIT */

#ifndef SOUNDSERVER_H
#define SOUNDSERVER_H

#include "common.h"

// includes of other idl definitions
#include "artsflow.h"
#include "kmedia2.h"

class ByteSoundProducer;
class SimpleSoundServer;
class WavPlayObject;

class ByteSoundProducer_base : virtual public SynthModule_base {
public:
	static unsigned long _IID; // interface ID

	static ByteSoundProducer_base *_create(const std::string& subClass = "ByteSoundProducer");
	static ByteSoundProducer_base *_fromString(std::string objectref);
	static ByteSoundProducer_base *_fromReference(ObjectReference ref, bool needcopy);

	inline ByteSoundProducer_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual vector<std::string> _defaultPortsIn() const;
	virtual vector<std::string> _defaultPortsOut() const;

	void *_cast(unsigned long iid);

	virtual long samplingRate() = 0;
	virtual long channels() = 0;
	virtual long bits() = 0;
};

class ByteSoundProducer_stub : virtual public ByteSoundProducer_base, virtual public SynthModule_stub {
protected:
	ByteSoundProducer_stub();

public:
	ByteSoundProducer_stub(Connection *connection, long objectID);

	long samplingRate();
	long channels();
	long bits();
};

class ByteSoundProducer_skel : virtual public ByteSoundProducer_base, virtual public SynthModule_skel {
protected:
	// variables for streams
	ByteAsyncStream outdata;                  // outgoing stream

	// handler for asynchronous streams
	virtual void request_outdata(DataPacket<mcopbyte> *);

public:
	ByteSoundProducer_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void dispatch(Buffer *request, Buffer *result,long methodID);
	void notify(const Notification& notification);
};

#include "reference.h"
#include "flowsystem.h"

class ByteSoundProducer : public SmartWrapper {
private:
	static Object_base* _Creator();
	ByteSoundProducer_base *_cache;
	inline ByteSoundProducer_base *_method_call() {
		_pool->checkcreate();
		if(_pool->base) {
			_cache=(ByteSoundProducer_base *)_pool->base->_cast(ByteSoundProducer_base::_IID);
			assert(_cache);
		}
		return _cache;
	}

public:
	inline ByteSoundProducer() : SmartWrapper(_Creator), _cache(0) {}
	inline ByteSoundProducer(const SubClass& s) :
		SmartWrapper(ByteSoundProducer_base::_create(s.string())), _cache(0) {}
	inline ByteSoundProducer(const Reference &r) :
		SmartWrapper(r.isString()?(ByteSoundProducer_base::_fromString(r.string())):(ByteSoundProducer_base::_fromReference(r.reference(),true))), _cache(0) {}
	inline ByteSoundProducer(ByteSoundProducer_base* b) : SmartWrapper(b), _cache(0) {}
	inline ByteSoundProducer(const ByteSoundProducer& target) : SmartWrapper(target._pool), _cache(target._cache) {}
	inline ByteSoundProducer(SmartWrapper::Pool& p) : SmartWrapper(p), _cache(0) {}
	inline ByteSoundProducer& operator=(const ByteSoundProducer& target) {
		if (_pool == target._pool) return *this;
		_pool->Dec();
		_pool = target._pool;
		_cache = target._cache;
		_pool->Inc();
		return *this;
	}
	inline operator SynthModule() const { return SynthModule(*_pool); }
	inline operator Object() const { return Object(*_pool); }
	inline ByteSoundProducer_base* _base() {return _cache?_cache:_method_call();}

	inline long samplingRate() {return _cache?_cache->samplingRate():_method_call()->samplingRate();}
	inline long channels() {return _cache?_cache->channels():_method_call()->channels();}
	inline long bits() {return _cache?_cache->bits():_method_call()->bits();}
	inline AutoSuspendState autoSuspend() {return _cache?_cache->autoSuspend():_method_call()->autoSuspend();}
	inline void start() {return _cache?_cache->start():_method_call()->start();}
	inline void stop() {return _cache?_cache->stop():_method_call()->stop();}
	inline void streamInit() {return _cache?_cache->streamInit():_method_call()->streamInit();}
	inline void streamStart() {return _cache?_cache->streamStart():_method_call()->streamStart();}
	inline void streamEnd() {return _cache?_cache->streamEnd():_method_call()->streamEnd();}
};

class SimpleSoundServer_base : virtual public PlayObjectFactory_base {
public:
	static unsigned long _IID; // interface ID

	static SimpleSoundServer_base *_create(const std::string& subClass = "SimpleSoundServer");
	static SimpleSoundServer_base *_fromString(std::string objectref);
	static SimpleSoundServer_base *_fromReference(ObjectReference ref, bool needcopy);

	inline SimpleSoundServer_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual vector<std::string> _defaultPortsIn() const;
	virtual vector<std::string> _defaultPortsOut() const;

	void *_cast(unsigned long iid);

	virtual StereoEffectStack outstack() = 0;
	virtual float minStreamBufferTime() = 0;
	virtual float serverBufferTime() = 0;
	virtual long play(const std::string& filename) = 0;
	virtual void attach(ByteSoundProducer producer) = 0;
	virtual void detach(ByteSoundProducer producer) = 0;
	virtual Object createObject(const std::string& name) = 0;
};

class SimpleSoundServer_stub : virtual public SimpleSoundServer_base, virtual public PlayObjectFactory_stub {
protected:
	SimpleSoundServer_stub();

public:
	SimpleSoundServer_stub(Connection *connection, long objectID);

	StereoEffectStack outstack();
	float minStreamBufferTime();
	float serverBufferTime();
	long play(const std::string& filename);
	void attach(ByteSoundProducer producer);
	void detach(ByteSoundProducer producer);
	Object createObject(const std::string& name);
};

class SimpleSoundServer_skel : virtual public SimpleSoundServer_base, virtual public PlayObjectFactory_skel {
public:
	SimpleSoundServer_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"

class SimpleSoundServer : public SmartWrapper {
private:
	static Object_base* _Creator();
	SimpleSoundServer_base *_cache;
	inline SimpleSoundServer_base *_method_call() {
		_pool->checkcreate();
		if(_pool->base) {
			_cache=(SimpleSoundServer_base *)_pool->base->_cast(SimpleSoundServer_base::_IID);
			assert(_cache);
		}
		return _cache;
	}

public:
	inline SimpleSoundServer() : SmartWrapper(_Creator), _cache(0) {}
	inline SimpleSoundServer(const SubClass& s) :
		SmartWrapper(SimpleSoundServer_base::_create(s.string())), _cache(0) {}
	inline SimpleSoundServer(const Reference &r) :
		SmartWrapper(r.isString()?(SimpleSoundServer_base::_fromString(r.string())):(SimpleSoundServer_base::_fromReference(r.reference(),true))), _cache(0) {}
	inline SimpleSoundServer(SimpleSoundServer_base* b) : SmartWrapper(b), _cache(0) {}
	inline SimpleSoundServer(const SimpleSoundServer& target) : SmartWrapper(target._pool), _cache(target._cache) {}
	inline SimpleSoundServer(SmartWrapper::Pool& p) : SmartWrapper(p), _cache(0) {}
	inline SimpleSoundServer& operator=(const SimpleSoundServer& target) {
		if (_pool == target._pool) return *this;
		_pool->Dec();
		_pool = target._pool;
		_cache = target._cache;
		_pool->Inc();
		return *this;
	}
	inline operator PlayObjectFactory() const { return PlayObjectFactory(*_pool); }
	inline operator Object() const { return Object(*_pool); }
	inline SimpleSoundServer_base* _base() {return _cache?_cache:_method_call();}

	inline StereoEffectStack outstack() {return _cache?_cache->outstack():_method_call()->outstack();}
	inline float minStreamBufferTime() {return _cache?_cache->minStreamBufferTime():_method_call()->minStreamBufferTime();}
	inline float serverBufferTime() {return _cache?_cache->serverBufferTime():_method_call()->serverBufferTime();}
	inline long play(const std::string& filename) {return _cache?_cache->play(filename):_method_call()->play(filename);}
	inline void attach(ByteSoundProducer producer) {return _cache?_cache->attach(producer):_method_call()->attach(producer);}
	inline void detach(ByteSoundProducer producer) {return _cache?_cache->detach(producer):_method_call()->detach(producer);}
	inline Object createObject(const std::string& name) {return _cache?_cache->createObject(name):_method_call()->createObject(name);}
	inline PlayObject createPlayObject(const std::string& filename) {return _cache?_cache->createPlayObject(filename):_method_call()->createPlayObject(filename);}
};

class WavPlayObject_base : virtual public PlayObject_base,
	virtual public SynthModule_base {
public:
	static unsigned long _IID; // interface ID

	static WavPlayObject_base *_create(const std::string& subClass = "WavPlayObject");
	static WavPlayObject_base *_fromString(std::string objectref);
	static WavPlayObject_base *_fromReference(ObjectReference ref, bool needcopy);

	inline WavPlayObject_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual vector<std::string> _defaultPortsIn() const;
	virtual vector<std::string> _defaultPortsOut() const;

	void *_cast(unsigned long iid);

};

class WavPlayObject_stub : virtual public WavPlayObject_base, virtual public PlayObject_stub,
	virtual public SynthModule_stub {
protected:
	WavPlayObject_stub();

public:
	WavPlayObject_stub(Connection *connection, long objectID);

};

class WavPlayObject_skel : virtual public WavPlayObject_base, virtual public PlayObject_skel,
	virtual public SynthModule_skel {
protected:
	// variables for streams
	float *left;                              // outgoing stream
	float *right;                             // outgoing stream

public:
	WavPlayObject_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	void _buildMethodTable();
	void dispatch(Buffer *request, Buffer *result,long methodID);
};

#include "reference.h"
#include "flowsystem.h"

class WavPlayObject : public SmartWrapper {
private:
	static Object_base* _Creator();
	WavPlayObject_base *_cache;
	inline WavPlayObject_base *_method_call() {
		_pool->checkcreate();
		if(_pool->base) {
			_cache=(WavPlayObject_base *)_pool->base->_cast(WavPlayObject_base::_IID);
			assert(_cache);
		}
		return _cache;
	}

public:
	inline WavPlayObject() : SmartWrapper(_Creator), _cache(0) {}
	inline WavPlayObject(const SubClass& s) :
		SmartWrapper(WavPlayObject_base::_create(s.string())), _cache(0) {}
	inline WavPlayObject(const Reference &r) :
		SmartWrapper(r.isString()?(WavPlayObject_base::_fromString(r.string())):(WavPlayObject_base::_fromReference(r.reference(),true))), _cache(0) {}
	inline WavPlayObject(WavPlayObject_base* b) : SmartWrapper(b), _cache(0) {}
	inline WavPlayObject(const WavPlayObject& target) : SmartWrapper(target._pool), _cache(target._cache) {}
	inline WavPlayObject(SmartWrapper::Pool& p) : SmartWrapper(p), _cache(0) {}
	inline WavPlayObject& operator=(const WavPlayObject& target) {
		if (_pool == target._pool) return *this;
		_pool->Dec();
		_pool = target._pool;
		_cache = target._cache;
		_pool->Inc();
		return *this;
	}
	inline operator PlayObject() const { return PlayObject(*_pool); }
	inline operator PlayObject_private() const { return PlayObject_private(*_pool); }
	inline operator SynthModule() const { return SynthModule(*_pool); }
	inline operator Object() const { return Object(*_pool); }
	inline WavPlayObject_base* _base() {return _cache?_cache:_method_call();}

	inline std::string description() {return _cache?_cache->description():_method_call()->description();}
	inline void description(const std::string& newValue) {_cache?_cache->description(newValue):_method_call()->description(newValue);}
	inline poTime* currentTime() {return _cache?_cache->currentTime():_method_call()->currentTime();}
	inline void currentTime(const poTime& newValue) {_cache?_cache->currentTime(newValue):_method_call()->currentTime(newValue);}
	inline poTime* overallTime() {return _cache?_cache->overallTime():_method_call()->overallTime();}
	inline poCapabilities capabilities() {return _cache?_cache->capabilities():_method_call()->capabilities();}
	inline std::string mediaName() {return _cache?_cache->mediaName():_method_call()->mediaName();}
	inline poState state() {return _cache?_cache->state():_method_call()->state();}
	inline AutoSuspendState autoSuspend() {return _cache?_cache->autoSuspend():_method_call()->autoSuspend();}
	inline void play() {return _cache?_cache->play():_method_call()->play();}
	inline void seek(const poTime& newTime) {return _cache?_cache->seek(newTime):_method_call()->seek(newTime);}
	inline void pause() {return _cache?_cache->pause():_method_call()->pause();}
	inline bool loadMedia(const std::string& filename) {return _cache?_cache->loadMedia(filename):_method_call()->loadMedia(filename);}
	inline void start() {return _cache?_cache->start():_method_call()->start();}
	inline void stop() {return _cache?_cache->stop():_method_call()->stop();}
	inline void streamInit() {return _cache?_cache->streamInit():_method_call()->streamInit();}
	inline void streamStart() {return _cache?_cache->streamStart():_method_call()->streamStart();}
	inline void streamEnd() {return _cache?_cache->streamEnd():_method_call()->streamEnd();}
};

#endif /* SOUNDSERVER_H */
